<?php

/*
Plugin Name: درگاه پرداخت الکترونیک سپهر برای EDD
Plugin URI: http://www.softiran.org
Description: ماژول درگاه پرداخت آنلاین پرداخت الکترونیک سپهر 
Version: 1.0
Author: softiran.org
Author URI: http://www.softiran.org
*/

function edd_add_gateway_pas($gateways)
{
	global $edd_options;
	return array_merge($gateways, array(
				'pas' => array(
					'admin_label'    => 'Pas',
					'checkout_label' => $edd_options['pas_gatename']
				)
			)
		);
}
add_filter('edd_payment_gateways', 'edd_add_gateway_pas');

function edd_pas_rial ($formatted, $currency, $price) {

	return $price . ' ریال';
}
add_filter( 'edd_rial_currency_filter_after', 'edd_pas_rial', 10, 3 );

function edd_send_to_gateway_pas($purchase_data)
{
	global $edd_options;
	$payment_data = array( 
			'price'        => $purchase_data['price'], 
			'date'         => $purchase_data['date'], 
			'user_email'   => $purchase_data['post_data']['edd_email'],
			'purchase_key' => $purchase_data['purchase_key'],
			'currency'     => $edd_options['currency'],
			'downloads'    => $purchase_data['downloads'],
			'cart_details' => $purchase_data['cart_details'],
			'user_info'    => $purchase_data['user_info'],
			'status'       => 'pending'
		);
		
	if ($payment = edd_insert_payment($payment_data))
	{
		$callBackUrl = add_query_arg('gateway', 'pas', get_permalink($edd_options['success_page']));
		$return = add_query_arg('succ', 'Y', $callBackUrl);
		$price = (ceil($payment_data['price']));
		
		$redirectAddress = ($return);
		$amount = trim($price);
		$merchant = trim($edd_options['pas_merchant']);
		$terminal = trim($edd_options['pas_terminal']);
		$invoiceNumber = time();
		@session_start();
		$_SESSION['price'] = $price;
		$_SESSION['payment_id'] = $payment;
		$_SESSION['user_email'] = $payment_data['user_email'];
		
		
		$params ='terminalID='.$terminal.'&Amount='.$amount.'&callbackURL='.urlencode($redirectAddress).'&invoiceID='.$invoiceNumber;
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, 'https://mabna.shaparak.ir:8081/V1/PeymentApi/GetToken');
		curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$res = curl_exec($ch);
		curl_close($ch);
		if($res)
		{
			$res = json_decode($res,true);
			if($res['Status'] == '0')
			{	  
				echo '<form id="paymentUTLfrm" action="https://mabna.shaparak.ir:8080" method="POST">
					<input type="hidden" id="TerminalID" name="TerminalID" value="'.$terminal.'">
					<input type="hidden" id="token" name="token" value="'.$res['Accesstoken'].'">
					</form><script>
					function submitmabna() {
					document.getElementById("paymentUTLfrm").submit();
					}
					window.onload=submitmabna; </script>';
			}else
			{
				echo ('خطا در ساخت توکن <br/> کد خطا :'.$res['Status']);
				die;
			}
		}
		else
		{
			echo ('پورت 8081 در هاست شما بسته است !');
			die;
		}
	


		
	}
	else
	{
		edd_send_back_to_checkout('?payment-mode='.$purchase_data['post_data']['edd-gateway']);
	}
}
add_action('edd_gateway_pas', 'edd_send_to_gateway_pas');

function edd_gateway_pas_verify()
{
	global $edd_options,$wpdb;
	@session_start();
	
	if (isset($_REQUEST['gateway']) && $_REQUEST['gateway'] == 'pas' && isset($_REQUEST['succ']) && $_REQUEST['succ'] == 'Y')
	{
		if( isset($_POST['respcode']) && $_POST['respcode'] == '0' )
		{
			$postmeta = $wpdb->get_row($wpdb->prepare("SELECT count(*) as cc  FROM $wpdb->comments WHERE comment_content LIKE %s LIMIT 1",'%'.$_POST['digitalreceipt'].'%'));
			if($postmeta->cc == 0)
			{
				$terminal = trim($edd_options['pas_terminal']);
				$params ='digitalreceipt='.$_POST['digitalreceipt'].'&Tid='.$terminal;
				$ch = curl_init();
				curl_setopt($ch, CURLOPT_URL, 'https://mabna.shaparak.ir:8081/V1/PeymentApi/Advice');
				curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				$res = curl_exec($ch);
				curl_close($ch);
				$result = json_decode($res,true);
				 if (strtoupper($result['Status']) == 'OK') 
				 {
					 
					 if(floatval($result['ReturnId'])  == floatval($_SESSION['price']))
					{
						$RefNum = $_POST['digitalreceipt'];
						$rrn = $_POST['rrn'];
						edd_insert_payment_note($_SESSION['payment_id'],'رسید دیجیتال : '.$RefNum . ' کد پیگیری :'.$rrn);
						edd_empty_cart();
						edd_update_payment_status($_SESSION['payment_id'], 'publish');
						wp_mail( get_bloginfo('admin_email'), 'پرداخت کامل در سایت', 'پرداخت کامل شد <br/> شماره پیگیری : '.$rrn );
						wp_mail( $_SESSION['user_email'], 'پرداخت شما کامل شد', 'پرداخت کامل شد <br/> شماره پیگیری : '.$rrn );
						$_SESSION['payment_id'] = 0;
						unset($_SESSION);
						edd_send_to_success_page();
						exit;
					}else
					{
						$res = 'مبلغ واریز با قیمت محصول برابر نیست ، مبلغ واریزی :'.$result['ReturnId'];
					}
					 
				}
				else
				{
					switch($result['ReturnId'])
					{
						case '-1' : $res = 'تراکنش پیدا نشد';break;
						case '-2' : $res = 'تراکنش قبلا Reverse شده است';break;
						case '-3' : $res = 'خطا عمومی';break;
						case '-4' : $res = 'امکان انجام درخواست برای این تراکنش وجود ندارد';break;
						case '-5' : $res = 'آدرس IP پذیرنده نامعتبر است';break;
						default  : $res = 'خطای ناشناس : '.$result['ReturnId'];break;
						
					}
				}
			}
			else
			{
				$res = 'رسید قبلا استفاده شده است';
			}	
		}else
		{
			$res = 'برگشت نا موفق از درگاه';
		}
		$state = 'false';
		if(isset($_SESSION['payment_id']))
		{
			$state = edd_get_payment_status($_SESSION['payment_id'], true);
		}
		
		if(strtolower($state) != 'complete')
		{
			edd_insert_payment_note($_SESSION['payment_id'], 'Error : '.$res);
			edd_update_payment_status($_SESSION['payment_id'], 'failed');
			$failed_page = get_permalink($edd_options['failure_page']);
		}
		$_SESSION['payment_id'] = 0;
		unset($_SESSION);
		wp_redirect( $failed_page );
		exit;
			
		
	}
}


add_action('init', 'edd_gateway_pas_verify');

function edd_gateway_pas_setting($settings)
{
	return array_merge( $settings, array (
				array (
					'id'   => 'pas_setting',
					'name' => 'pas Setting',
					'desc' => 'pas Setting',
					'type' => 'header'
				),
				array (
					'id'   => 'pas_terminal',
					'name' => 'Terminal',
					'desc' => 'Terminal',
					'type' => 'text',
					'size' => 'regular'
				),
				array (
					'id'   => 'pas_gatename',
					'name' => 'نام درگاه پرداخت',
					'desc' => 'نام بانک را وارد کنید',
					'type' => 'text',
					'size' => 'regular'
				)
			)
		);
}
add_filter('edd_settings_gateways', 'edd_gateway_pas_setting');

function edd_pas_cc_form_filter(){}
add_filter( 'edd_pas_cc_form', 'edd_pas_cc_form_filter' );


?>